//---------------------------------------------------------------------------
//
//      DLLvOCۃNX
//
//---------------------------------------------------------------------------
#ifndef dll_plugin_h
#define dll_plugin_h

#include <vcl.h>
#include <windows.h>

//---------------------------------------------------------------------------
class Dll_plugin
{
protected :
    HANDLE handle;
    AnsiString dllname;
    //DLL̊֐̃AhXZbg
    //I[o[[h
    virtual bool adress_set(const HANDLE) = 0;

private :

public :
// Constructor
    Dll_plugin()
    {
        handle = NULL;
        dllname = "";
    };

// Destructor
    virtual ~Dll_plugin()
    {
        if (handle != NULL)
            FreeLibrary(handle); // Cu
    };

    bool dll_load(const char *dllpath)
    {
        bool ret = false;

        if (handle != NULL) {
            FreeLibrary(handle);
            handle = NULL;
        }

        handle = LoadLibrary(dllpath);

        if (handle != NULL) {
            ret = adress_set(handle);
            if (ret) dllname = dllpath;
        }

        return	ret;
    };

    AnsiString __fastcall Getdllname(void)
    {
        return dllname;
    }

};

#endif /* dll_plugin.h */
