//---------------------------------------------------------------------------
#ifndef Unit3H
#define Unit3H

#include "spi_manage.h"
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <FileCtrl.hpp>
#include <ExtCtrls.hpp> //MinimizeName
//---------------------------------------------------------------------------
class TDialogForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
        TPageControl *PC;
        TTabSheet *QueueTS;
        TTabSheet *NoticeTS;
    TPanel *UPanel;
    TLabel *L1;
    TLabel *SrcLabel;
    TButton *PauseButton;
    TButton *StopButton;
    TButton *CloseButton;
    TMemo *NoticeMemo;
    TListBox *QueueLB;
        void __fastcall CloseButtonClick(TObject *Sender);
        void __fastcall StopButtonClick(TObject *Sender);
        void __fastcall PauseButtonClick(TObject *Sender);
    void __fastcall QueueLBClick(TObject *Sender);
private:	// [U[錾
        void __fastcall FilesAddList(const AnsiString &path);
        void __fastcall AddErr(const int err, const AnsiString &filepath, const AnsiString &spiname);
        int __fastcall spicheck(AnsiString filepath, AnsiString desdir, char *pmem, long len);
        int __fastcall spi2xpi(char *src, char *des, char *mem, long len, Susie_plugin *pspi);
        int __fastcall to8bit(HLOCAL *bmpinfo, HLOCAL *bmpdata, const int color);
        int __fastcall to24bit(HLOCAL *bmpinfo, HLOCAL *bmpdata, const int color);
        int State;
        int Overwrite;
#define ABC_OVERWRITE_ALWAYS    0 //ɏ㏑
#define ABC_OVERWRITE_VERIFY    1 //₢킹
#define ABC_OVERWRITE_ALWAYS_NO 3 //ɏ㏑͂Ȃ

public:		// [U[錾
        __fastcall TDialogForm(TComponent* Owner);
        void __fastcall Init(void);
        void __fastcall Play(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TDialogForm *DialogForm;
//---------------------------------------------------------------------------
#endif
