//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>

#include "spi_manage.h"
#include "xpi_manage.h"
#include "DropEdit.h"
#include "DropListBox.h"

#define SPI_MAN MainForm->spi_man
#define XPI_MAN MainForm->xpi_man
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
        TGroupBox *SrcGB;
        TGroupBox *OutGB;
        TButton *AddButton;
        TButton *FileAddButton;
        TButton *DirAddButton;
        TButton *DeleteButton;
        TButton *OutButton;
        TGroupBox *OptionGB;
        TButton *StartButton;
        TCheckBox *OverWriteCB;
        TButton *AboutButton;
        TGroupBox *OutFormatGB;
        TLabel *L1;
        TLabel *L2;
        TComboBox *Bit8CB;
        TComboBox *Bit16CB;
        TCheckBox *UnknownOutputCB;
        TButton *CloseButton;
        TButton *OpenButton;
        TDropListBox *SrcLB;
        TDropEdit *SrcEdit;
        TDropEdit *OutEdit;
    TButton *SaveButton;
    TButton *abc8setButton;
    TButton *abc16setButton;
    TButton *InpListButton;
        void __fastcall StartButtonClick(TObject *Sender);
        void __fastcall AboutButtonClick(TObject *Sender);
        void __fastcall FileAddButtonClick(TObject *Sender);
        void __fastcall DeleteButtonClick(TObject *Sender);
        void __fastcall AddButtonClick(TObject *Sender);
        void __fastcall CloseButtonClick(TObject *Sender);
        void __fastcall DirAddButtonClick(TObject *Sender);
        void __fastcall OutButtonClick(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall OpenButtonClick(TObject *Sender);
        void __fastcall SaveButtonClick(TObject *Sender);
        void __fastcall SrcLBDropFiles(TObject *Sender,
          TStringList *DropFileList);
        void __fastcall SrcEditDropFiles(TObject *Sender,
          char *DropFileName);
    void __fastcall abc8setButtonClick(TObject *Sender);
    void __fastcall abc16setButtonClick(TObject *Sender);
    void __fastcall InpListButtonClick(TObject *Sender);
private:	// [U[錾
        AnsiString __fastcall OpenFolderDialog(void);
        bool __fastcall StartEnableCheck(void);
        void __fastcall ConvertStart(void);
        void __fastcall LoadOption(void);
        void __fastcall SetFormat(TComboBox *cb, const AnsiString &format);
public:		// [U[錾
        __fastcall TMainForm(TComponent* Owner);
        Spi_manager spi_man;
        Xpi_manager xpi_man;

};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
 