//---------------------------------------------------------------------------
//
//        SusievOCǗNX
//
//---------------------------------------------------------------------------
#include <stdio.h>
#include <vcl.h>
#pragma hdrstop

#include "spi_manage.h"
#include "misc.h"
//---------------------------------------------------------------------------
//t@C̓WJ`FbN
// ΉĂvOCNXւ̃|C^Ԃ
// ΉNULLԂ
Susie_plugin* __fastcall Spi_manager::filecheck(char *src, char *mem)
{
    Susie_plugin *ret_spi = NULL;
    std::vector<Susie_plugin *>::iterator ite;
    FILE *fp;
    char data[4000];
    char *pdata;

    if (mem == NULL) {
        // t@C
        fp = fopen(src, "rb");
        if (fp == NULL) return ret_spi;
        fread(data, 1, 4000, fp);
        fclose(fp);
        pdata = data;
    } else {
        // 
        pdata = mem;
    }

    // ΉvOC邩
    // 00AMD
    for (ite = spiam_array.begin(); ite != spiam_array.end() && ret_spi == NULL; ite++) {
try {
        if (*ite != NULL)
        if ((*ite)->IsSupported(src, (DWORD)pdata) != 0) {
            // ΉĂ
            ret_spi = *ite;
        }
} catch (...) {
        //throw;
}
    }
if (ret_spi == NULL) {
    for (ite = spiin_array.begin(); ite != spiin_array.end() && ret_spi == NULL; ite++) {
try {
        if (*ite != NULL)
        if ((*ite)->IsSupported(src, (DWORD)pdata) != 0) {
            // ΉĂ
            ret_spi = *ite;
        }
} catch (...) {
        //throw;
}
    }
}

    return ret_spi;
}
//---------------------------------------------------------------------------
// vOC̏𓾂
//num:vOC̃CfbNXԍ
//infono:GetPluginInfoinfono
AnsiString __fastcall Spi_manager::spiinfonum(int num, int infono)
{
    if (num < 0 || num >= (spiam_count + spiin_count))
        return (AnsiString)"";

    Susie_plugin *pspi = NULL;
    char buf[512] = "";
    int buflen = 511;

    // 00AMJEg
    if (num < spiam_count) {
        pspi = spiam_array[num];
    } else {
        pspi = spiin_array[num -spiam_count];
    }
    if (spi_info(pspi, infono, buf, buflen)) {
        buf[511] = '\0';
        return (AnsiString)buf;
    }

    return (AnsiString)"";
}
//---------------------------------------------------------------------------
//wtH_ɂvOC[h
void __fastcall Spi_manager::loadall(const char *path)
{
    Susie_plugin *spi;
    HANDLE hf;
    WIN32_FIND_DATA ff;

    // vOC̃pXݒ
    AnsiString findpath;
    AnsiString tmppath;
    findpath = (AnsiString)path +"*.spi";

    // vOČ
    hf = FindFirstFile(findpath.c_str(), &ff);
    if (hf == INVALID_HANDLE_VALUE) return;

    while (hf != INVALID_HANDLE_VALUE) {
        spi = new Susie_plugin;
        tmppath = (AnsiString)path +ff.cFileName;

        // vOC[h
        if (!spi->dll_load(tmppath.c_str())) {
            // load error
            delete spi;
        } else {
            //ǉ
            if (spi->getversion() == VER_00AM) {
                spiam_array.push_back(spi);
                spiam_count++;
            } else {
                spiin_array.push_back(spi);
                spiin_count++;
            }
        }
        if (FindNextFile(hf, &ff) == false)
            break;
    }
    FindClose(hf);
}
//---------------------------------------------------------------------------
//wvOC[h
bool __fastcall Spi_manager::loadone(const char *path)
{
    Susie_plugin *spi;

    spi = new Susie_plugin;
    // vOC[h
    if (!spi->dll_load(path)) {
        // load error
        delete spi;
        return false;
    }

    //ǉ
    if (spi->getversion() == VER_00AM) {
        spiam_array.push_back(spi);
        spiam_count++;
    } else {
        spiin_array.push_back(spi);
        spiin_count++;
    }

    return true;
}
//---------------------------------------------------------------------------


//SusievOC̏𓾂
bool __fastcall Spi_manager::spi_info(Susie_plugin *pcspi,
                    const int infono, const LPSTR buf, const int buflen)
{
    bool ret = false;

    if (pcspi != NULL) {
        try {
            ret = pcspi->GetPluginInfo(infono, buf, buflen);
        } catch (...) {
            //throw;
        }
    }
    return ret;
}
//---------------------------------------------------------------------------
//摜̏𓾂
int __fastcall Spi_manager::spi_picinfo(Susie_plugin *pcspi,
                   const LPSTR buf, const long len, const unsigned int flag,
                      PictureInfo *lpInfo)
{
    int ret = SPI_NO_FUNCTION;

    if (pcspi == NULL) {
        if (IS_FILEIN(flag)) {
            //fBXNt@C
            pcspi = filecheck(buf, NULL);
        } else {
            //̃C[W
            pcspi = filecheck(NULL, buf);
        }
        if (pcspi == NULL) return SPI_NOT_SUPPORT;
    }

    if (pcspi->getversion() == VER_00IN) {
        try {
            ret = pcspi->GetPictureInfo(buf, len, flag, lpInfo);
        } catch (...) {
            ret = SPI_FATAL_ERR;
            //throw;
        }
    }

    return ret;
}
//---------------------------------------------------------------------------
//摜𓾂
int __fastcall Spi_manager::spi_pic(Susie_plugin *pcspi,
                     const LPSTR buf, const long len, const unsigned int flag,
                     HANDLE *pHBInfo, HANDLE *pHBm,
                     SPI_PROGRESS lpPrgressCallback, const long lData)
{
    int ret = SPI_NO_FUNCTION;

    if (pcspi == NULL) {
        if (IS_FILEIN(flag)) {
            //fBXNt@C
            pcspi = filecheck(buf, NULL);
        } else {
            //̃C[W
            pcspi = filecheck(NULL, buf);
        }
        if (pcspi == NULL) return ret;
    }

    if (pcspi->getversion() == VER_00IN) {
        if (lpPrgressCallback == NULL)
            lpPrgressCallback = spi_null_callback;
        try {
            ret = pcspi->GetPicture(buf, len, flag, pHBInfo, pHBm,
                               lpPrgressCallback, lData);
        } catch (...) {
            ret = SPI_FATAL_ERR;
            //throw;
        }
    }

    return ret;
}
//---------------------------------------------------------------------------
//摜ivr[j𓾂
int __fastcall Spi_manager::spi_prev(Susie_plugin *pcspi,
                     const LPSTR buf, const long len, const unsigned int flag,
                     HANDLE *pHBInfo, HANDLE *pHBm,
                     SPI_PROGRESS lpPrgressCallback, const long lData)
{
    int ret = SPI_NO_FUNCTION;

    if (pcspi == NULL) {
        if (IS_FILEIN(flag)) {
            //fBXNt@C
            pcspi = filecheck(buf, NULL);
        } else {
            //̃C[W
            pcspi = filecheck(NULL, buf);
        }
        if (pcspi == NULL) return ret;
    }

    if (pcspi->getversion() == VER_00IN) {
        if (lpPrgressCallback == NULL)
            lpPrgressCallback = spi_null_callback;
        try {
            ret = pcspi->GetPreview(buf, len, flag, pHBInfo, pHBm,
                               lpPrgressCallback, lData);
        } catch (...) {
            ret = SPI_FATAL_ERR;
            //throw;
        }
    }

    return ret;
}
//---------------------------------------------------------------------------
//A[JCȕ𓾂
int __fastcall Spi_manager::spi_arcinfo(Susie_plugin *pcspi,
                      const LPSTR buf, const long len,
                      const unsigned int flag, HLOCAL *lphInf)
{
    int ret = SPI_NO_FUNCTION;

    if (pcspi == NULL) {
        if (IS_FILEIN(flag)) {
            //fBXNt@C
            pcspi = filecheck(buf, NULL);
        } else {
            //̃C[W
            pcspi = filecheck(NULL, buf);
        }
        if (pcspi == NULL) return ret;
    }

    if (pcspi->getversion() == VER_00AM) {
        *lphInf = NULL; //for lhasad.spi
        try {
            ret = pcspi->GetArchiveInfo(buf, len, flag, lphInf);
            if (ret == SPI_NOT_SUPPORT && *lphInf != NULL) {
                ret = SPI_ALL_RIGHT; //for lhasad.spi
            }
        } catch (...) {
            ret = SPI_FATAL_ERR;
            //throw;
        }
    }

    return ret;
}
//---------------------------------------------------------------------------
//A[JCut@C̏𓾂
int __fastcall Spi_manager::spi_fileinfo(Susie_plugin *pcspi,
                    const LPSTR buf, const long len, const LPSTR filename,
                    const unsigned int flag, fileInfo *lpInfo)
{
    int ret = SPI_NO_FUNCTION;

    if (pcspi == NULL) {
        if (IS_FILEIN(flag)) {
            //fBXNt@C
            pcspi = filecheck(buf, NULL);
        } else {
            //̃C[W
            pcspi = filecheck(NULL, buf);
        }
        if (pcspi == NULL) return ret;
    }

    if (pcspi->getversion() == VER_00AM) {
        try {
            ret = pcspi->GetFileInfo(buf, len, filename, flag, lpInfo);
        } catch (...) {
            ret = SPI_FATAL_ERR;
            //throw;
        }
    }

    return ret;
}
//---------------------------------------------------------------------------
//t@C𓾂
int __fastcall Spi_manager::spi_getfile(Susie_plugin *pcspi,
                    const LPSTR src, const long len, const LPSTR dest, const unsigned int flag,
                    SPI_PROGRESS lpPrgressCallback, const long lData)
{
    int ret = SPI_NO_FUNCTION;

    if (pcspi == NULL) {
        if (IS_FILEIN(flag)) {
            //fBXNt@C
            pcspi = filecheck(src, NULL);
        } else {
            //̃C[W
            pcspi = filecheck(NULL, src);
        }
        if (pcspi == NULL) return ret;
    }

    if (pcspi->getversion() == VER_00AM) {
        if (lpPrgressCallback == NULL)
            lpPrgressCallback = spi_null_callback;
        try {
           ret = pcspi->GetFile(src, len, dest, flag,
                        lpPrgressCallback, lData);
        } catch (...) {
            ret = SPI_FATAL_ERR;
            //throw;
        }
    }

    return ret;
}
//---------------------------------------------------------------------------
//SusievOC̐ݒ_CAO\
//num:vOC̃CfbNXԍ
bool __fastcall Spi_manager::spi_confignum(const int num, const HWND parent, const int func)
{
    bool ret = false;
    Susie_plugin *pcspi;
    if (num < 0 || num >= (spiam_count + spiin_count)) return ret;
    if (num <= spiam_count -1) {
        pcspi = spiam_array[num];
    } else {
        pcspi = spiin_array[num -spiam_count];
    }

    if (pcspi->ConfigurationDlg != NULL) {
        try {
            if (pcspi->ConfigurationDlg(parent, func) != 0)
                ret = true;
        } catch (...) {
            //throw;
        }
    }

    return ret;
}
//---------------------------------------------------------------------------
//SusievOC̐ݒ_CAO\
bool __fastcall Spi_manager::spi_config(Susie_plugin *pcspi, const HWND parent, const int func)
{
    bool ret = false;
    if (pcspi == NULL) return ret;
    if (pcspi->ConfigurationDlg != NULL) {
        try {
            if (pcspi->ConfigurationDlg(parent, func) != 0)
                ret = true;
        } catch (...) {
            //throw;
        }
    }

    return ret;
}
//---------------------------------------------------------------------------


//pX摜𓾂
//G[R[hԂ
//ɓɓΉ
int __fastcall Spi_manager::spi2dib(const AnsiString &filename,
    HANDLE *pHBInfo, HANDLE *pHBm, HANDLE *pHfile, const bool preview)
{
    //Ή`FbN
    int ret;
    Susie_plugin *pcspi;
    char *pfimg = NULL;
    AnsiString tmpname = filename;
    AnsiString arcpath = ""; //ɓ̃pX
    unsigned int flag = SPI_FLAG_FILE;
    ret = ExistsCheck(tmpname);
if (pHfile == NULL && ret != NO_EXISTS) {
//t@C̃pXϊ
    if (ret == IS_DIR) {
        //tH_͖낤...
        return SPI_FILE_READ_ERROR;
    }
    //t@C݂
    //DIBQbg
    pcspi = filecheck(tmpname.c_str(), pfimg);
    if (pcspi->getversion() == VER_00IN) {
        if (preview) {
            ret = spi_prev(pcspi, tmpname.c_str(), 0, flag, pHBInfo, pHBm, NULL, 0);
            if (ret != SPI_ALL_RIGHT) {
                ret = spi_pic(pcspi, tmpname.c_str(), 0, flag, pHBInfo, pHBm, NULL, 0);
            }
        } else {
            ret = spi_pic(pcspi, tmpname.c_str(), 0, flag, pHBInfo, pHBm, NULL, 0);
        }
    } else {
        return SPI_NOT_SUPPORT;
    }
    return ret;

}

//C[Wϊ
    flag = SPI_FLAG_MEM;
if (tmpname == "") {
    //C[W̓t@C炵
    //DIBQbg
    pfimg = (char *)LocalLock(*pHfile);
    pcspi = filecheck(tmpname.c_str(), pfimg);
    if (pcspi->getversion() == VER_00IN) {
        if (preview) {
            ret = spi_prev(pcspi, pfimg, LocalSize(*pHfile), flag, pHBInfo, pHBm, NULL, 0);
            if (ret != SPI_ALL_RIGHT) {
                ret = spi_pic(pcspi, pfimg, LocalSize(*pHfile), flag, pHBInfo, pHBm, NULL, 0);
            }
        } else {
            ret = spi_pic(pcspi, pfimg, LocalSize(*pHfile), flag, pHBInfo, pHBm, NULL, 0);
        }
        LocalUnlock(*pHfile);
        return ret;
    }
    LocalUnlock(*pHfile);
    return SPI_NOT_SUPPORT;
}

//wt@Co
    HANDLE dest = NULL;
    ret = GetFileEx(tmpname, "", pHfile, &dest);
    if (ret != SPI_ALL_RIGHT) {
        if (dest != NULL) LocalFree(dest);
        return ret;
    }
    ret = spi2dib("", pHBInfo, pHBm, &dest, preview);
    if (dest != NULL) LocalFree(dest);
    return ret;
}
//---------------------------------------------------------------------------
//ɂt@C𓾂iɓɑΉj
//G[R[hԂ
//filename:~t@C̃pX
//arcname:~ɓ̃pXBċApBʂ""Ă
//HANDLE *src:ɃC[WBt@C͂NULLI
//HANDLE *dest:ԋpp
int __fastcall Spi_manager::GetFileEx(const AnsiString &filename, const AnsiString &arcname,
                   HANDLE *src, HANDLE *dest)
{
    int ret;
    Susie_plugin *pcspi;
    fileInfo finfo;
    HANDLE htmp = NULL;
    AnsiString tmpname = filename;
    AnsiString arcpath = arcname;

if (arcpath == "") {
    //t@C
    //Ƃ̏ɂ
for (;;) {
    ret = ExistsCheck(tmpname);
    if (ret == NO_EXISTS) {
        //ɓt@Cw肵Ă̂
        if (arcpath != "") arcpath = "\\" +arcpath;
        arcpath = ExtractFileName(tmpname) +arcpath;
        tmpname = ExtractDirName(tmpname);
        if (tmpname.Length() <= 3) {
            //ႢH
            return SPI_FILE_READ_ERROR;
        }
    } else if (ret == IS_FILE) {
        //t@C݂
        //`FbNȂƖċAăX^bNI[o[t[
        if (arcpath == "") return SPI_NOT_SUPPORT;
        break;
    } else {
        //tH_͖낤...
        return SPI_FILE_READ_ERROR;
    }
} //end for (;;)
    //ċA
    //arcpath:ɓpX
    //tmpname:Ƀt@C
    ret = GetFileEx(tmpname, arcpath, NULL, dest);
    return ret;
}

if (src == NULL) {
    //t@C
    //ɂ͓ς
    //wt@C͏ɂɂ邩H
    pcspi = filecheck(tmpname.c_str(), NULL);
    if (pcspi->getversion() != VER_00AM) {
        return SPI_NOT_SUPPORT;
    }
    memset(&finfo, 0, sizeof(finfo));
    ret = spi_fileinfo(pcspi, tmpname.c_str(), 0, arcpath.c_str(), SPI_FLAG_FILE, &finfo);
    if (ret == SPI_ALL_RIGHT) {
        ret = spi_getfile(pcspi, tmpname.c_str(), finfo.position, (char *)dest, SPI_FLAG_OUTMEM, NULL, 0);
        if (ret != SPI_ALL_RIGHT) {
            return ret;
        }
        return ret;
    }
for (;;) {
    //ɓɂ
    int ofset = arcpath.AnsiPos("\\");
    if (ofset == 0) {
        //...
        return SPI_FILE_READ_ERROR;
    }
    tmpname = arcpath.SubString(1, ofset -1);
    arcpath = arcpath.SubString(ofset +1, arcpath.Length() -ofset);
    memset(&finfo, 0, sizeof(finfo));
    ret = spi_fileinfo(pcspi, filename.c_str(), 0, tmpname.c_str(), SPI_FLAG_FILE, &finfo);
    if (ret == SPI_ALL_RIGHT) {
        ret = spi_getfile(pcspi, filename.c_str(), finfo.position, (char *)&htmp, SPI_FLAG_OUTMEM, NULL, 0);
        if (ret != SPI_ALL_RIGHT) {
            return ret;
        }
        //ɍċA
        ret = GetFileEx("", arcpath, &htmp, dest);
        LocalFree(htmp);
        return ret;
    }
} //end for (;;)
}

    //
    //ɂ͓ς
    //wt@C͏ɂɂ邩H
    char *pfimg = (char *)LocalLock(*src);
    pcspi = filecheck(tmpname.c_str(), pfimg);
    if (pcspi->getversion() != VER_00AM) {
        LocalUnlock(*src);
        return SPI_NOT_SUPPORT;
    }
    memset(&finfo, 0, sizeof(finfo));
    ret = spi_fileinfo(pcspi, pfimg, LocalSize(*src), arcpath.c_str(), SPI_FLAG_MEM, &finfo);
    if (ret == SPI_ALL_RIGHT) {
        ret = spi_getfile(pcspi, pfimg +finfo.position, LocalSize(*src) -finfo.position, (char *)dest, SPI_FLAG_OUTMEM | SPI_FLAG_MEM, NULL, 0);
        LocalUnlock(*src);
        if (ret != SPI_ALL_RIGHT) {
            return ret;
        }
        return ret;
    }
for (;;) {
    //ɓɂ
    int ofset = arcpath.AnsiPos("\\");
    if (ofset == 0) {
        //...
        LocalUnlock(*src);
        return SPI_FILE_READ_ERROR;
    }
    tmpname = arcpath.SubString(0, ofset -1);
    arcpath = arcpath.SubString(ofset +1, arcpath.Length() -ofset -1);
    memset(&finfo, 0, sizeof(finfo));
    ret = spi_fileinfo(pcspi, pfimg, LocalSize(*src), arcpath.c_str(), SPI_FLAG_MEM, &finfo);
    if (ret == SPI_ALL_RIGHT) {
        ret = spi_getfile(pcspi, pfimg +finfo.position, LocalSize(*src) -finfo.position, (char *)&htmp, SPI_FLAG_OUTMEM | SPI_FLAG_MEM, NULL, 0);
        LocalUnlock(*src);
        if (ret != SPI_ALL_RIGHT) {
            return ret;
        }
        //ɍċA
        ret = GetFileEx("", arcpath, &htmp, dest);
        LocalFree(htmp);
        return ret;
    }
} //end for (;;)
}
//---------------------------------------------------------------------------


// **************************************************************
// ɉȂR[obN֐
//   R[obNw肵ȂƗvOĈ
// **************************************************************
static int __stdcall spi_null_callback(int nNum, int nDenom, long lData)
{
    Sleep(0); //ȂƂȂ
    return 0;
}
//---------------------------------------------------------------------------

