//---------------------------------------------------------------------------
//
//      SusievOCNX
//
//---------------------------------------------------------------------------
#ifndef susie_plugin_h
#define susie_plugin_h

#include "dll_plugin.h"

#pragma pack(push)
#pragma pack(1) //\̂̃oE1oCgɂ pragma
typedef struct PictureInfo
{
    long left,top;       /* 摜WJʒu */
    long width;          /* 摜̕(pixel) */
    long height;         /* 摜̍(pixel) */
    WORD x_density;      /* f̐x */
    WORD y_density;      /* f̐x */
    short colorDepth;    /* fbit */
    HLOCAL hInfo;        /* 摜̃eLXg */
} PictureInfo;

typedef struct fileInfo
{
    unsigned char method[8];    /* k@̎ */
    unsigned long position;     /* t@Cł̈ʒu */
    unsigned long compsize;     /* kꂽTCY */
    unsigned long filesize;     /* ̃t@CTCY */
    /*time_t*/ long timestamp;  /* t@C̍XV */
    char path[200];             /* ΃pX */
    char filename[200];         /* t@Cl[ */
    unsigned long crc;          /* CRC */
} fileInfo;
#pragma pack(pop)

/*-------------------------------------------------------------------------*/
/* G[R[h                                                            */
/*-------------------------------------------------------------------------*/
#define SPI_NO_FUNCTION       -1  /* ̋@\̓CvgĂȂ */
#define SPI_ALL_RIGHT          0  /* I */
#define SPI_ABORT              1  /* R[obN֐0Ԃ̂œWJ𒆎~ */
#define SPI_NOT_SUPPORT        2  /* m̃tH[}bg */
#define SPI_OUT_OF_ORDER       3  /* f[^Ă */
#define SPI_NO_MEMORY          4  /* [mۏoȂ */
#define SPI_MEMORY_ERROR       5  /* [G[ */
#define SPI_FILE_READ_ERROR    6  /* t@C[hG[ */
#define	SPI_WINDOW_ERROR       7  /* JȂ (J) */
#define SPI_OTHER_ERROR        8  /* G[ */
#define	SPI_FILE_WRITE_ERROR   9  /* ݃G[ (J) */
#define	SPI_END_OF_FILE       10  /* t@CI[ (J) */

typedef int (CALLBACK *SPI_PROGRESS)(int, int, long);
//---------------------------------------------------------------------------
class Susie_plugin : public Dll_plugin
{
private:
#define VERUNKNOWN 0
#define VER_00IN   1
#define VER_00AM   2
    int    spi_ver;    // SPIo[W

public:
/* Common Function */
    // vOC̏𓾂
    int _export __stdcall (*GetPluginInfo)(int infono, LPSTR buf, int buflen);

    // vOC̐ݒ_CAO\
    int _export __stdcall (*ConfigurationDlg)(HWND parent, int fnc);

/* "00IN" ̊֐ */
    // WJ\ȃt@C`ׂ
    int _export __stdcall (*IsSupported)(LPSTR filename, DWORD dw);

    // 摜t@CɊւ𓾂
    int _export __stdcall (*GetPictureInfo)(LPSTR buf, long len,
                           unsigned int flag, PictureInfo *lpInfo);
    // 摜WJ
    int _export __stdcall (*GetPicture)(LPSTR buf, long len, unsigned int flag,
                                     HANDLE *pHBInfo, HANDLE *pHBm,
                        SPI_PROGRESS lpPrgressCallback, long lData);

    // 摜̃vr[
    int _export __stdcall (*GetPreview)(LPSTR buf, long len, unsigned int flag,
                                     HANDLE *pHBInfo, HANDLE *pHBm,
                        SPI_PROGRESS lpPrgressCallback, long lData);

/* "00AM" ̊֐ */
    // A[JCûׂẴt@C̏擾
    int _export __stdcall (*GetArchiveInfo)(LPSTR buf, long len,
                                         unsigned int flag, HLOCAL *lphInf);

    // A[JCu̎w肵t@C̏擾
    int _export __stdcall (*GetFileInfo)(LPSTR buf, long len, LPSTR filename,
                                         unsigned int flag, fileInfo *lpInfo);

    // A[JCũt@C擾
    int _export __stdcall (*GetFile)(LPSTR src, long len, LPSTR dest,
                             unsigned int flag,
                        SPI_PROGRESS lpPrgressCallback, long lData);

// RXgN^
    Susie_plugin()
    {
        spi_ver = VERUNKNOWN;
    };

// fXgN^
    ~Susie_plugin()
    {
    };

    // AhXZbg
    bool adress_set(const HANDLE)
    {
        bool ret = false;

        // AhX
        (void *)GetPluginInfo    = GetProcAddress(handle, "GetPluginInfo");
        (void *)IsSupported      = GetProcAddress(handle, "IsSupported");
        (void *)GetPictureInfo   = GetProcAddress(handle, "GetPictureInfo");
        (void *)GetPicture       = GetProcAddress(handle, "GetPicture");
        (void *)GetPreview       = GetProcAddress(handle, "GetPreview");
        (void *)GetArchiveInfo   = GetProcAddress(handle, "GetArchiveInfo");
        (void *)GetFileInfo      = GetProcAddress(handle, "GetFileInfo");
        (void *)GetFile          = GetProcAddress(handle, "GetFile");
        (void *)ConfigurationDlg = GetProcAddress(handle, "ConfigurationDlg");

        // G[o[W`FbN
        ret = (GetPluginInfo != NULL) & (IsSupported != NULL);
        if (GetArchiveInfo != NULL && GetFile != NULL) {
            //GetFileInfo͏dvȂ
            spi_ver = VER_00AM;
        } else if (GetPicture != NULL) {
            //GetPictureInfo, GetPreview ͏dvȂ
            spi_ver = VER_00IN;
        } else {
            spi_ver = VERUNKNOWN;
            return false;
        }

        return ret;
    };

    int getversion(void)
    {
        return spi_ver;
    }

};

#endif /* susie_plugin.h */
