//---------------------------------------------------------------------------
//
//      o̓vOCǗNX
//
//---------------------------------------------------------------------------
#ifndef xpi_namage_h
#define xpi_namage_h

#include "abc_plugin.h"
#include <vector>

//---------------------------------------------------------------------------
class Xpi_manager
{
private:
    std::vector <Abc_plugin *> xpi_array;
    int xpi_count;
    Abc_plugin *xpi_8;   // Wrbgȉ̂Ƃgpo̓vOC
    Abc_plugin *xpi_16;  // 16rbgȏ̂Ƃgpo̓vOC
    Abc_plugin *now_xpi; // ݎgĂo̓vOC

    bool __fastcall set_xpi(const int num); // now_xpiZbg
    void __fastcall loadxpi(const char *path);    // vOC[h

public:
// Constructor
    Xpi_manager()
    {
        xpi_count = 0;
    }

// Destructor
    ~Xpi_manager()
    {
        std::vector<Abc_plugin *>::iterator ite;
        if (!xpi_array.empty())
            for (ite = xpi_array.begin(); ite != xpi_array.end(); ite++) {
                delete *ite;
            }
    }

    void __fastcall load(const char *path);    // vOC[h
    bool __fastcall set_xpi8(const int num);  // xpi_8 Zbg
    bool __fastcall set_xpi16(const int num); // xpi_16Zbg
    bool __fastcall xpi_info(const int num, const int infono, const LPSTR buf, const int buflen);
    bool __fastcall xpi_ccheck8(const short color);
    bool __fastcall xpi_ccheck16(const short color);
    int __fastcall xpi_pic(char *filepath, const unsigned int flag,
                        HANDLE *pHBInfo, HANDLE *pHBm, PictureInfo *lpInfo,
        int (CALLBACK *lpPrgressCallback)(int,int,long),
                        const long lData);
    bool __fastcall xpi_config(const int num, const HWND parent, const int fnc);
    int __fastcall get_count(void)
    {
        return xpi_count;
    }

};

// **************************************************************
// ɉȂR[obN֐
//   Ô
// **************************************************************
static int __stdcall xpi_null_callback(int nNum, int nDenom, long lData);

/*-------------------------------------------------------------------------*/
/* G[R[h                                                            */
/*-------------------------------------------------------------------------*/
#define XPI_FATAL_ERR       -102  /* vIG[iOj */

#endif /* xpi_manage.h */
