//---------------------------------------------------------------------------
//
//        o̓vOCǗNX
//
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "xpi_manage.h"
//---------------------------------------------------------------------------
//vOCZbg
bool __fastcall Xpi_manager::set_xpi(const int num)
{
    bool ret = false;

    if (num < 0 || num >= xpi_count) return ret;
    now_xpi = xpi_array[num];
    ret = true;

    return ret;
}
//---------------------------------------------------------------------------
//vOCZbg
bool __fastcall Xpi_manager::set_xpi8(const int num)
{
    bool ret = false;

    if (num < 0 || num >= xpi_count) return ret;
    xpi_8 = xpi_array[num];
    ret = true;

    return ret;
}
//---------------------------------------------------------------------------
//vOCZbg
bool __fastcall Xpi_manager::set_xpi16(const int num)
{
    bool ret = false;

    if (num < 0 || num >= xpi_count) return ret;
    xpi_16 = xpi_array[num];
    ret = true;

    return ret;
}
//---------------------------------------------------------------------------
//wtH_ɂvOC[h
void __fastcall Xpi_manager::load(const char *path)
{
    // vOC̃pXݒ
    AnsiString findpath;
    //͎݊Ȃ
    //findpath = (AnsiString)path +"*.dll";
    //loadxpi(findpath.c_str());
    findpath = (AnsiString)path +"*.xpi";
    loadxpi(findpath.c_str());
}
//---------------------------------------------------------------------------
//wtH_ɂvOC[h
void __fastcall Xpi_manager::loadxpi(const char *path)
{
    Abc_plugin *xpi;
    HANDLE hf;
    WIN32_FIND_DATA ff;

    // vOC̃pXݒ
    AnsiString findpath;
    AnsiString pathdir;
    findpath = (AnsiString)path;
    pathdir = ExtractFilePath(findpath);

    // vOČ
    hf = FindFirstFile(findpath.c_str(), &ff);
    if (hf == INVALID_HANDLE_VALUE) return;

    while (hf != INVALID_HANDLE_VALUE) {
        xpi = new Abc_plugin;
        AnsiString xpipath = pathdir +ff.cFileName;

        // vOC[h
        if (!xpi->dll_load(xpipath.c_str())) {
            // load error
            delete xpi;
        } else {
            //ǉ
            xpi_array.push_back(xpi);
            xpi_count++;
        }
        if (FindNextFile(hf, &ff) == false)
            break;
    }
    FindClose(hf);
}
//---------------------------------------------------------------------------
//ΉĂF`FbN
bool __fastcall Xpi_manager::xpi_ccheck8(const short color)
{
    int ret = 0;

try {
    ret = xpi_8->IsSupported(color);
    if (ret != 0) now_xpi = xpi_8;
} catch (...) {
        //throw;
}

    return ret;
}
//---------------------------------------------------------------------------
//ΉĂF`FbN
bool __fastcall Xpi_manager::xpi_ccheck16(const short color)
{
    int ret = 0;

try {
    ret = xpi_16->IsSupported(color);
    if (ret != 0) now_xpi = xpi_16;
} catch (...) {
        //throw;
}

    return ret;
}
//---------------------------------------------------------------------------
//ϊĕۑ
int __fastcall Xpi_manager::xpi_pic(char *filepath, const unsigned int flag,
                        HANDLE *pHBInfo, HANDLE *pHBm,
                        PictureInfo *lpInfo,
                        SPI_PROGRESS lpPrgressCallback, const long lData)
{
    int ret = XPI_OTHER_ERROR;

try {
    if (now_xpi != NULL) {
        if (lpPrgressCallback == NULL)
            lpPrgressCallback = xpi_null_callback;
        ret = now_xpi->CreatePicture(filepath, flag,
                        pHBInfo, pHBm, lpInfo,
                        lpPrgressCallback, lData);
    }
} catch (...) {
    ret = XPI_FATAL_ERR;
        //throw;
}

    return ret;
}
//---------------------------------------------------------------------------
//o̓vOC̏𓾂
bool __fastcall Xpi_manager::xpi_info(const int num, const int infono, const LPSTR buf, const int buflen)
{
    bool ret = false;

try {
    if (set_xpi(num)) {
        ret = now_xpi->GetPluginInfo(infono, buf, buflen);
    } else if (num == -1) {
        ret = now_xpi->GetPluginInfo(infono, buf, buflen);
    }
} catch (...) {
        //throw;
}

    return ret;
}
//---------------------------------------------------------------------------
//o̓vOC̐ݒ_CAO\
bool __fastcall Xpi_manager::xpi_config(const int num, const HWND parent, const int func)
{
    bool ret = false;

try {
    if (set_xpi(num))
        if (now_xpi->ConfigurationDlg != NULL)
            if (now_xpi->ConfigurationDlg(parent, func) == XPI_ALL_RIGHT)
                ret = true;
} catch (...) {
        //throw;
}

    return ret;
}
//---------------------------------------------------------------------------


// **************************************************************
// ɉȂR[obN֐
//   Ô
// **************************************************************
static int __stdcall xpi_null_callback(int nNum, int nDenom, long lData)
{
    return 0;
}
//---------------------------------------------------------------------------
